//@author: vux
//@help: template for standard shaders
//@tags: template
//@credits: 

float4x4 tVP : VIEWPROJECTION;
StructuredBuffer<float> valueBuffer;
float valueDefault;
 
struct VS_IN
{
	float4 PosO : POSITION;
	float4 TexCd : TEXCOORD0;
};

struct vs2ps
{
    float4 PosWVP: SV_POSITION;
    float4 TexCd: TEXCOORD0;
};

struct PS_OUT
{
	float4 Color:SV_TARGET;
	float Depth:SV_DEPTH;
};

vs2ps VS(VS_IN input)
{
    vs2ps output;
    output.PosWVP  = mul(input.PosO,tVP);
    output.TexCd = input.TexCd;
    return output;
}


PS_OUT PS(vs2ps In)
{
	PS_OUT Out;

	// load a vaule from SB
	float myValue = valueDefault;
	uint vCount, dummy;	
	valueBuffer.GetDimensions(vCount, dummy);
	if (vCount > 0)  myValue = valueBuffer[0];
	
	Out.Color = float4(In.TexCd.xy,0,1);
	Out.Depth = In.PosWVP.z/In.PosWVP.w;
	
	//error here, writing to color is fine, but depth is not happy
	Out.Color += myValue; //ok
	//Out.Depth += myValue; // not ok
	
    return Out;
}





technique10 Constant
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_5_0, VS() ) );
		SetPixelShader( CompileShader( ps_5_0, PS() ) );
	}
}




